#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include "func_extern.h"
#include "control.h"
#include "irs_ts_ws.h"
#include "pwm_enc.h"
#include "uss.h"

int main(int argc, char *argv[])
{
	/*
	search_count : count of search
	target_post  : target post number
	target_code  : IRS code of the post to get now
		This variable is defined as gloabl varialble.
	*/
	int search_count=1;
	int target_post=0,search_end=0;
	int sort_select=0;
	int ret;
	int loop=0;
	int i,dis=0;
	char *p;
	FILE *fp;

	fp=fopen("post_data.txt","w");
	post.got_number=0;

	printf("Initialize\n");
	ret=initialize();

	p=argv[1];
	printf("%s\n",p);
	if(*p=='s') sort_select=1; // sort from small to big
	if(*p=='b') sort_select=2; // sort from big to small
	if(*p=='2') gamecount=2; // second TRY
	printf("argv[1] = %d\n",sort_select);

	if(gamecount==2) search_count=dataread();

	/*
	MODE : move_std
	*/
	p=argv[2];
	printf("%s\n",p);
	if(*p=='0') dis=1350;
	if(*p=='1') dis=1500;
	if(*p=='2') dis=1650;
	move_centerpos(dis);
	usleep(SLEEPTIME_MAIN);
/*	
	post.ang[0]=304;
	post.ang[1]=206;
	post.dis[0]=917;
	post.dis[1]=1015;
	post.number=2;
*/	
//	post2post_calc(1,0);
//	goto END;

	/*
	MODE : search_post
	*/

	if(gamecount==1){

		pthread_create(&uss_task, &attr_uss, &uss_read, (void *)1);

	//	### TEST : correct_direction1 ###
	//	correct_direction1(1);
	//	goto END;

	//	### TEST : lqr_rotate ###
	//	for(i=0;i<10;i++){
	//		lqr_rotate(13,500);
	//		usleep(1000000);
	//	}
	//	goto END;	

		printf("Searched post number =%d\n",post.number);
		while(post.number!=POST_NUM){
			usleep(SLEEPTIME_MAIN);
			post_search_t(search_count);
			printf("Searched post number =%d\n",post.number);
			post_sort(search_end,1);
			for(i=0;;i++){
				if(post.dis[i]==0) break;
				printf("### post.ang[%d]=%d  post.dis[%d]=%d\n",i,post.ang[i],i,post.dis[i]);
			}
			loop++;
			if(loop>=10){
				printf("give up searching...\n");
				break;
			}
		}

		for(i=0;i<post.number;i++){
			printf("post.ang[%d]=%d  post.dis[%d]=%d\n",i,post.ang[i],i,post.dis[i]);
		}
		datawrite_angdis();

		pthread_cancel(uss_task);

		post_sort(search_end,sort_select);	// sort posts' data
	}

	/* 
	MODE :	search_postnum
		move_std2post
		move_post2post

	1st  : move_std2post    > search_postnum
	2nd  : move_post2post   > search_postnum
	3rd~ : move around post > move_post2post   > search_postnum
	*/
	pthread_create(&uss_task2, &attr_uss, &uss_read2, (void *)1);
	usleep(SLEEPTIME_MAIN);

	while(search_count<=POST_NUM){
		target_post = search_count-1;

		if(search_count==1 || gamecount==2){
			post_approach(target_post);
			if(gamecount==2) gamecount=3;
		}else{
			if(search_count!=2 || gamecount!=3){
				circle_adj(p2p_data.ang_adj, search_end, target_post);
				usleep(SLEEPTIME_MAIN);
			}
			post2post_calc(target_post, search_end);
			post2post_move(target_post, search_end);
			gamecount=0;
		}
		usleep(SLEEPTIME_MAIN);

		post_code_get(target_post);
		usleep(SLEEPTIME_MAIN);
		datawrite_code();

		if(post.code[target_post]==post.got_number+1){
			post_get(target_post);
			post.got_post[target_post]=1;
			post.got_number++;
		}
		search_count++;
	}
	search_end=2;

	/*
	MODE :	get_post
		move_post2post
	*/
	angmax=post.ang[post.number-1];
	post_sort(search_end,sort_select);	// sort posts' data in order of their "number".
	target_post=post.got_number;

	printf("Post get start\n");

	while(post.got_number<POST_NUM){
		if(gamecount==2){
			post_approach(target_post);
			usleep(300000);
			moveOnCircleRadius();
			usleep(300000);
			gamecount=3;
		}else{
			if(gamecount!=3){
			circle_adj(p2p_data.ang_adj, search_end, target_post);
				usleep(SLEEPTIME_MAIN);
			}else{
				gamecount=0;
			}
			if(post2post_calc(target_post, search_end) > 0){
				post2post_jammer(target_post);
			}else{
				post2post_move(target_post, search_end);
			}
			usleep(SLEEPTIME_MAIN);
		}

		post_get(target_post);
		usleep(SLEEPTIME_MAIN);

		target_post++;
		post.got_number++;
		if(search_end==2) search_end=1;
	}

	pthread_cancel(uss_task2);

	usleep(SLEEPTIME_MAIN);
	pwm_both_data(0,0);
	usleep(400000);
	pwm_enco_stop();
	usleep(400000);
	printf("All posts have been got\n");
	printf("Original Post postion\n");
	fprintf(fp,"Original Post postion\n");
	for(i=0;i<post.number;i++){
		printf("Post No[%d]  Angle=%d  Distance=%d\n",i,post.ang[i],post.dis[i]);
		fprintf(fp,"Post No[%d]  Angle=%d  Distance=%d\n",i,post.ang[i],post.dis[i]);
	}
	printf("Tempral Post postion\n");
	for(i=0;i<post.number;i++){
		printf("Post No[%d]  Angle=%d  Distance=%d\n",i,post_tmp.ang[i],post_tmp.dis[i]);
		fprintf(fp,"Post No[%d]  Angle=%d  Distance=%d\n",i,post_tmp.ang[i],post_tmp.dis[i]);
	}

END:
	// close all device file 
	close(fd0);
	close(fd1);
	close(fd2);
	close(fd3);
	//close(fd4);
	//close(fd5);
	//close(fd6);
	//close(fd7);
	close(ctl);
	fclose(fp);
	return 0;
}
