#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include <math.h>
#include "func_extern.h"
#include "control.h"
#include "irs_ts_ws.h"
#include "pwm_enc.h"
#include "uss.h"

int triangleCheck();

int post2post_calc(int target_post, int search_end){
	int i,postnum_now,postnum_next,num_angmax=0;
	int ang1,ang2,dis1,dis2;
	int jammer_count=0;
	double tmp;
	p2p_data.ang=0; p2p_data.dis=0; p2p_data.dis_adj=0; p2p_data.ang12=0;
	triangle=0;
	
	/* p2p_data.ang12 : angle between post1 and post2, 0 <= p2p_data.ang12 < 180 */
	
	printf("post2post() is called.\n");

	if(search_end==2){
		for(i=0;i<post.number;i++){
			if(post.ang[i]==angmax) num_angmax=i;
		}
		postnum_now = num_angmax;
		postnum_next = post.got_number;
	}else{
		postnum_now = target_post-1;
		postnum_next = target_post;
	}
	ang1=post.ang[postnum_now];
	dis1=post.dis[postnum_now];
	ang2=post.ang[postnum_next];
	dis2=post.dis[postnum_next];

	printf("ang1 : %d\n",ang1);
	printf("ang2 : %d\n",ang2);
	printf("dis1 : %d\n",dis1);
	printf("dis2 : %d\n",dis2);

	p2p_data.ang1 = ang1;
	p2p_data.dis1 = dis1;
		
	/* ### calc ### */
	if(search_end>0) p2p_data.dis_adj = circle_radious;
	else if(post.got_post[target_post-1]==1) p2p_data.dis_adj = circle_radious;
	else p2p_data.dis_adj = post_diameter/2 + MCENTER_TS_DIS + DIS_BACK;
	dis1 -= p2p_data.dis_adj;

	if(search_end>0) p2p_data.dis_adj = circle_radious;
	if(search_end==0) p2p_data.dis_adj = post_diameter/2+MCENTER_TS_DIS+DIS_BACK;
	
	if(abs(ang1-ang2)==180){
		printf("ang1=ang2\n");
		p2p_data.dis=dis1+dis2-p2p_data.dis_adj;
		p2p_data.ang=180;
		rotate_dir_select=2;
	}else{
		if(abs(ang1-ang2)<180){
			if(ang1<ang2){rotate_dir_select=1;} // turn left
			if(ang1>ang2){rotate_dir_select=2;} // turn right
			p2p_data.ang12=abs(ang1-ang2);
		}
		if(abs(ang1-ang2)>180){
			if(ang1<ang2){rotate_dir_select=2;} // turn right
			if(ang1>ang2){rotate_dir_select=1;} // turn left
			p2p_data.ang12=360-abs(ang1-ang2);
		}
		
		p2p_data.dis=(int)sqrt(dis1*dis1+dis2*dis2-2*dis1*dis2*cos(p2p_data.ang12*M_PI/180.))-p2p_data.dis_adj;
		tmp=dis2*sin(p2p_data.ang12*M_PI/180.)/(p2p_data.dis+p2p_data.dis_adj);
		if(tmp>1.0) tmp=1.0;
		if(triangle==-1){
			printf("anti-shape Triangle!!\n");
			p2p_data.ang=(int)(asin(tmp)*180/M_PI);
		}else p2p_data.ang=180-(int)(asin(tmp)*180/M_PI);
	}

	p2p_data.ang_adj = p2p_data.ang-p2p_data.ang12;
	if(rotate_dir_select==1) printf("MIRS rotates left.\n");
	if(rotate_dir_select==2) printf("MIRS rotates right.\n");
	printf("ang : %d [deg]\n",p2p_data.ang);
	printf("dis : %d [mm]\n",p2p_data.dis+p2p_data.dis_adj);
	printf("post2post_calc() end.\n");

	if(search_end>0) jammer_count = post_crash_check(ang1,dis1,postnum_now,postnum_next);

	return jammer_count;
}

int post2post_move(int target_post, int search_end){
	int ang=0,dis=0,p_flag,distance;
	/* ### move ### */
	if(triangle==-1){
		ang=AROUND_ANG/2-p2p_data.ang;
		dis=p2p_data.dis-p2p_data.dis_adj-500;
		
		moveOnCircleRadius();
		lqr_rotate(90,90*20);
		usleep(300000);

		if(rotate_dir_select==1)
			lqr_circle(-circle_radious,ang,ang*40);
		if(rotate_dir_select==2)
			lqr_circle(-circle_radious,-ang,ang*40);
		usleep(300000);

		lqr_rotate(90,90*20);
	}else{
		if(rotate_dir_select==1) ang=p2p_data.ang-90;
		if(rotate_dir_select==2) ang=-1*p2p_data.ang-90;
		if(target_post==1 && search_end==0) ang+=90;
		if(gamecount==3 && search_end==1) ang+=90;
		if(ang>180 && ang<360) ang-=360;
		if(ang<-180 && ang>-360) ang+=360;
		dis=p2p_data.dis-p2p_data.dis_adj+100;
		lqr_rotate(ang,abs(ang)*20);
	}
	usleep(300000);

	p_flag = correct_direction1(target_post);
	
//	if(p_flag != 1){//there is post
	//determine the distance to go and move to the post
	distance=uss12 + USS_CORRECT - USS_MIN;
	printf("distance to go (by USS) : %d [mm]\n",distance);
	printf("distance to go (by p2p) : %d [mm]\n",dis);
	//lqr_straight((distance-100),(distance-100)*4);
	lqr_straight(dis,dis*4);
	correct_direction1(target_post);

	//move to the point of circe_radius
	if(search_end>0) moveOnCircleRadius();

	//determine return distance
	return_dist=post.dis[target_post]-circle_radious;

//	}else{//there is no post
//		printf("There is no post!\n");
//		return 9999;
//	}

	printf("post2post() finished.\n");
	return 0;
}

int post2post_jammer(int target_post){
	int distance;
	while(1){
		// move
		printf("move to jammer. : No.%d\n",jammer.number);
		if(rotate_dir_select==1){lqr_rotate(jammer.ang-90, (jammer.ang-90)*20);}
		if(rotate_dir_select==2){lqr_rotate(-1*jammer.ang-90, (jammer.ang+90)*20);}
		correct_direction1(jammer.number);
		distance = uss12+USS_CORRECT-USS_MIN;
		//lqr_straight((distance-100),(distance-100)*4);
		lqr_straight((jammer.dis-p2p_data.dis_adj+100), (jammer.dis-p2p_data.dis_adj+100)*4);
		correct_direction1(jammer.number);
		moveOnCircleRadius();

		// re-check
		if(post_crash_check(p2p_data.ang1,p2p_data.dis1,jammer.number,target_post) == 0) break;

		circle_adj((jammer.ang-jammer.ang1x), 1, target_post);
	}
	return 0;
}

void moveOnCircleRadius(){
	int i,tmp_left=0,tmp_right=0,error=0;
	for(i=0;i<3;i++){
		pwm_enco_start(10);
		usleep(40000);
		pwm_lqr_straight(DIS_FORWARD,DIS_FORWARD*20);
		usleep(40000);
		tmp_left=count.left_sum;
		tmp_right=count.right_sum;
		while(1){
			printf("%d %d\n",count.left_sum,count.right_sum);
			if(count.left_sum==tmp_left && count.right_sum==tmp_right){
				error++;
			}else{
				tmp_left=count.left_sum;
				tmp_right=count.right_sum;
				error=0;
			}
			if(ts[TS_POS]=='1' || error>60) break;
			usleep(50000);
		}
		//tire stop
		pwm_both_data(0,0);
		usleep(40000);
		//encoder task stop
		pwm_enco_stop();
		usleep(40000);
		usleep(500000);
		if(ts[TS_POS]=='1') break;
		if(error>60){
			i=-1;
			error=0;
			lqr_straight(-200,200*6);
			usleep(300000);
			correct_direction1(0);
			usleep(300000);
		}
	}
	lqr_straight(-45,1000);
	usleep(300000);
}

int triangleCheck(int dis1,int dis2,int dis12){
	int a,b,max;
	if(dis1>dis2 && dis1>dis12){
		max=dis1;
		a=dis2;
		b=dis12;
	}else if(dis2>dis1 && dis2>dis12){
		max=dis2;
		a=dis1;
		b=dis12;
	}else if(dis12>dis1 && dis12>dis2){
		max=dis12;
		a=dis1;
		b=dis2;
	}else{
		return 0;
	}

//	if(max*max>(a*a+b*b)) return -1;
//	else return 0;
	return 0;
}
