//remaked by t_yoshida
//2007 1 29

#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include "func_extern.h"
#include "control.h"
#include "irs_ts_ws.h"
#include "pwm_enc.h"
#include "uss.h"

#define PERI_ANG 5	//reading period
#define PLS_HOSEI 35	//hosei +[mm]
#define MNS_HOSEI 20	//hosei -[mm]
#define CLR_POINT 2	//clear point of total

int post_search_t(int center_count){

	struct dat{
		int ang[100];
		int dis[100];
		int flg[100];
	};

	struct dat dat;
	float lm,rm,lv,rv;
	int br;
	int i,j1,j2,j3,cnt=0,bef_cnt,aft_cnt,index,ang,dis;

	printf("***** post_search_t *****\n");

	for(i=0;i<100;i++){
		dat.ang[i]=0;
		dat.dis[i]=0;
		dat.flg[i]=0;
	}

	uss_msg.command=2;
	uss_msg.number=3;	//uss No.
	uss_msg.period=100;	//period[msec]
	write(ctl, &uss_msg, sizeof(uss_msg));
	printf("uss start\n");
	usleep(200000);

	pwm_enco_start(10);
	usleep(40000);
	pwm_lqr_rotate(360,9000);
	usleep(40000);
	count.br=0;
	printf("No\tuss_data\tangle\tdiff\n");
	while(count.br==0){
		encoder_data(&lm,&rm,&lv,&rv,&br);
		ang=(((lm+rm)/2)*360)/(2*pi*dist_ct);//pwm_enc.h
//		ang=(((-alw+arw)/2)*360)/(2*pi*dist_ct);
		if(ang<360 && (cnt==0 || ang-dat.ang[cnt-1]>PERI_ANG)){
			printf("%d\t",cnt);
			printf("%d\t",uss_data);
			printf("%d\t",ang);
			printf("%d\n",ang-dat.ang[cnt-1]);
			dat.ang[cnt]=ang;
			dat.dis[cnt]=uss_data;
			cnt++;
		}
	}
	pwm_both_data(0,0);
	usleep(40000);
	pwm_enco_stop();

	uss_msg.command=3;	//task stop
	write(ctl,&uss_msg,sizeof(uss_msg));
	printf("uss stop\n");

/**********************************************************/

	//remove large data
	for(i=0;i<100;i++){
		if(dat.dis[i]>USS_MAX){
			dat.flg[i]=1; //no data
		}
	}

JUDGE:

	//judgement and determin post

	//first. find minimum distance
	printf("\nfind minimum distance\n");
	index=-1;
	for(i=0;i<cnt;i++){
		if(dat.flg[i]==0){index=i;}
	}
	if(index==-1){
		goto END;
	}
	for(i=1;i<cnt;i++){
		if(dat.dis[index]>dat.dis[i] && dat.flg[i]==0){
			index=i;
		}
	}
	printf("minimun index=%d\n",index);
//	scanf("%d",&data);									//DEBUG

	//second. check before and after data

	//check AFTER data
	printf("\ncheck AFTER data\n");
	aft_cnt=0;
	for(i=index;i<index+6;i++){
		if(i>=cnt){j1=i-cnt;}else{j1=i;}
		if((i+1)>=cnt){j2=i+1-cnt;}else{j2=i+1;}
		if((i+2)>=cnt){j3=i+2-cnt;}else{j3=i+2;}
		dis=dat.dis[j2]+(dat.dis[j2]-dat.dis[j1]);	//rironti
		printf("judge dat.dis[%d]=%d - dis[%d]=%d -> dis[%d]=%d( %d )\n",j1,dat.dis[j1],j2,dat.dis[j2],j3,dat.dis[j3],dat.flg[j3]);
		if((dis+PLS_HOSEI>dat.dis[j3] && dis-MNS_HOSEI<dat.dis[j3]) && dat.flg[j3]==0){
			printf("OK\n");
			if(aft_cnt==0){aft_cnt+=2;}else{aft_cnt++;}
		}else{
			break;
		}
	}
	printf("after_count = %d\n",aft_cnt);
//	scanf("%d",&data);									//DEBUG

	//check BEFORE data
	printf("\ncheck BEFORE data\n");
	bef_cnt=0;
	for(i=index;i>index-6;i--){
		if(i<0){j1=i+cnt;}else{j1=i;}
		if((i-1)<0){j2=i-1+cnt;}else{j2=i-1;}
		if((i-2)<0){j3=i-2+cnt;}else{j3=i-2;}
		dis=dat.dis[j2]+(dat.dis[j2]-dat.dis[j1]);	//rironti
		printf("judge dat.dis[%d]=%d - dis[%d]=%d -> dis[%d]=%d( %d )\n",j1,dat.dis[j1],j2,dat.dis[j2],j3,dat.dis[j3],dat.flg[j3]);
		if((dis+PLS_HOSEI>dat.dis[j3] && dis-MNS_HOSEI<dat.dis[j3]) && dat.flg[j3]==0){
			printf("OK\n");
			if(bef_cnt==0){bef_cnt+=2;}else{bef_cnt++;}
		}else{
			break;
		}
	}
	printf("before_count = %d\n",bef_cnt);
//	scanf("%d",&data);									//DEBUG

	//third. judge total point
	printf("\njudge total point\n");
	printf("aft_cnt=%d, bef_cnt=%d\n",aft_cnt,bef_cnt);
	if((aft_cnt+bef_cnt)>=CLR_POINT){
		printf("there is POST !!!!\n");
		dat.flg[index]=2;	//<- post
		//remove checked data
		for(i=index+1;i<=index+aft_cnt;i++){
			if(i>=cnt){j1=i-cnt;}else{j1=i;}
			dat.flg[j1]=1; //no data
			printf("remove data: dat.dis[%d]=%d\n",j1,dat.dis[j1]);
		}
		for(i=index-1;i>=index-bef_cnt;i--){
			if(i<0){j1=i+cnt;}else{j1=i;}
			dat.flg[j1]=1; //no data
			printf("remove data: dat.dis[%d]=%d\n",j1,dat.dis[j1]);
		}
	}else{
		printf("there is NOT POST...\n");
		dat.flg[index]=1;
	}
//	scanf("%d",&data);									//DEBUG

	goto JUDGE;

END:
	printf("\nselect psot data\n");
	j1=0;
	for(i=0;i<cnt;i++){
		printf("check data: dat.dis[%d]=%d, flg[%d]=%d\n",i,dat.dis[i],i,dat.flg[i]);
		if(dat.flg[i]==2){
		ang=dat.ang[i]+POST_ANG_DIFF+90;
		while(ang>=360){ang-=360;}
		dis=dat.dis[i]+USS_CORRECT+MCENTER_USS3_DIS+post_diameter/2;
			printf("dat.ang[%d]=%d, dis[%d]=%d\n",i,dat.ang[i],i,dat.dis[i]);
			if(center_count==1){
				post.ang[j1]=ang;
				post.dis[j1]=dis;
			}else{
				post_tmp.ang[j1]=ang;
				post_tmp.dis[j1]=dis;
			}
			j1++;
		}
	}
	if(center_count==1){
		post.number=j1;
	}else{
		post_tmp.number=j1;
	}

	printf("***************************\n");

	return 0;
}
